package cn.iocoder.yudao.module.erp.service.autocode;

import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.erp.controller.admin.autocode.vo.*;
import cn.iocoder.yudao.module.erp.dal.dataobject.autocode.AutocodePartDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.erp.dal.mysql.autocode.AutocodePartMapper;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.erp.enums.ErrorCodeConstants.*;

/**
 * 编码规则组成 Service 实现类
 *
 * @author 内蒙必硕
 */
@Service
@Validated
public class AutocodePartServiceImpl implements AutocodePartService {

    @Resource
    private AutocodePartMapper autocodePartMapper;

    @Override
    public Long createAutocodePart(AutocodePartSaveReqVO createReqVO) {
        // 插入
        AutocodePartDO autocodePart = BeanUtils.toBean(createReqVO, AutocodePartDO.class);
        autocodePartMapper.insert(autocodePart);
        // 返回
        return autocodePart.getId();
    }

    @Override
    public void updateAutocodePart(AutocodePartSaveReqVO updateReqVO) {
        // 校验存在
        validateAutocodePartExists(updateReqVO.getId());
        // 更新
        AutocodePartDO updateObj = BeanUtils.toBean(updateReqVO, AutocodePartDO.class);
        autocodePartMapper.updateById(updateObj);
    }

    @Override
    public void deleteAutocodePart(Long id) {
        // 校验存在
        validateAutocodePartExists(id);
        // 删除
        autocodePartMapper.deleteById(id);
    }

    private void validateAutocodePartExists(Long id) {
        if (autocodePartMapper.selectById(id) == null) {
            throw exception(AUTOCODE_PART_NOT_EXISTS);
        }
    }

    @Override
    public AutocodePartDO getAutocodePart(Long id) {
        return autocodePartMapper.selectById(id);
    }

    @Override
    public PageResult<AutocodePartDO> getAutocodePartPage(AutocodePartPageReqVO pageReqVO) {
        return autocodePartMapper.selectPage(pageReqVO,pageReqVO.getRuleId());
    }

}